#include "stdafx.h"

char * g_szGainTableTitle = "Amplifier Gain Multiplier Table";

class CVwGainTable : public CDialog { 
	public : 
		CGainTable * m_pGainTable;

		//-- dialog controls 		
		CDlgEdit m_edtTableName;
		CDlgButton m_btnDelEntry;
		CDlgButton m_btnAddEntry;
		CDlgEdit m_aedtAmp[GAIN_MAXENTRIES];
		CDlgEdit m_aedtMult[GAIN_MAXENTRIES];
				
		//-- Initialize controls - fill hdw list and set controls to empty values or passed setup
		void InitializeControls( ) { 
			//-- set control handles
			m_edtTableName.SetHandle( GetDlgItem( m_hDlg, IDC_EDTTABLENAME), "Unique identifying name for this configuration" );
			m_btnDelEntry.SetHandle( GetDlgItem( m_hDlg, IDC_BTNDELENTRY ), "Decrease number of signals/multipliers" );
			m_btnAddEntry .SetHandle( GetDlgItem( m_hDlg, IDC_BTNADDENTRY ), "Increase number of signals/multipliers" );

			m_aedtAmp[0].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP0 ), "Output signal from amplifier" );
			m_aedtAmp[1].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP1 ), "Output signal from amplifier" );
			m_aedtAmp[2].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP2 ), "Output signal from amplifier" );
			m_aedtAmp[3].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP3 ), "Output signal from amplifier" );
			m_aedtAmp[4].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP4 ), "Output signal from amplifier" );
			m_aedtAmp[5].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP5 ), "Output signal from amplifier" );
			m_aedtAmp[6].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP6 ), "Output signal from amplifier" );
			m_aedtAmp[7].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP7 ), "Output signal from amplifier" );
			m_aedtAmp[8].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP8 ), "Output signal from amplifier" );
			m_aedtAmp[9].SetHandle( GetDlgItem( m_hDlg, IDC_EDTAMP9 ), "Output signal from amplifier" );

			m_aedtMult[0].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT0 ), "Multiplying factor to apply to data" );
			m_aedtMult[1].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT1 ), "Multiplying factor to apply to data" );
			m_aedtMult[2].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT2 ), "Multiplying factor to apply to data" );
			m_aedtMult[3].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT3 ), "Multiplying factor to apply to data" );
			m_aedtMult[4].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT4 ), "Multiplying factor to apply to data" );
			m_aedtMult[5].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT5 ), "Multiplying factor to apply to data" );
			m_aedtMult[6].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT6 ), "Multiplying factor to apply to data" );
			m_aedtMult[7].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT7 ), "Multiplying factor to apply to data" );
			m_aedtMult[8].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT8 ), "Multiplying factor to apply to data" );
			m_aedtMult[9].SetHandle( GetDlgItem( m_hDlg, IDC_EDTMULT9 ), "Multiplying factor to apply to data" );
			}
			
		void Setup( ) { 
			m_edtTableName.SetText( m_pGainTable->m_cTableName.ConstBuffer() );
			for( int i=0; i<GAIN_MAXENTRIES; ++i ) {
				m_aedtAmp[i].SetTextDouble( m_pGainTable->m_adSignal[i], "%f" );
				m_aedtMult[i].SetTextDouble( m_pGainTable->m_adMultiplier[i], "%f" );
				}
			if( m_pGainTable->m_bNew ) 
				ShowWindow( GetDlgItem( m_hDlg, IDC_BTNDELETE ), SW_HIDE );
			OnBtnChangeEntries( 0 );
			}
		
		void Teardown( ) { 
			m_edtTableName.GetText( &m_pGainTable->m_cTableName );
			for( int i=0; i<GAIN_MAXENTRIES; ++i ) {
				m_pGainTable->m_adSignal[i] = m_aedtAmp[i].GetTextDouble();
				m_pGainTable->m_adMultiplier[i] = m_aedtMult[i].GetTextDouble();
				}
			m_pGainTable->SetRanges();
			}

		//-----------------------------------------------------------------------------
		// Events and messages 
		
		//-- Delete : Confirm, then return IDYES
		void OnBtnDelete() { 
			if( IDYES==MessageBox( GetParent( m_hDlg ), "Delete this configuration ?", g_szGainTableTitle, MB_YESNO ) ) 
				EndDialog( m_hDlg, IDYES );
			}
			
		//-- OK : Get control data then return IDOK
		void OnBtnOK() { 
			Teardown( );
			EndDialog( m_hDlg, IDOK );
			}

		//-- Cancel : Return IDCANCEL
		void OnBtnCancel() { 
			EndDialog( m_hDlg, IDCANCEL );
			}
			
		//-- change enabled entry count 
		void OnBtnChangeEntries( int iIncr ) { 
			m_pGainTable->m_iEntries = min( max( 1, m_pGainTable->m_iEntries+iIncr ), GAIN_MAXENTRIES );
			for( int i=0; i<GAIN_MAXENTRIES; ++i ) { 
				m_aedtAmp[i].SetEnabled( i<m_pGainTable->m_iEntries );
				m_aedtMult[i].SetEnabled( i<m_pGainTable->m_iEntries );
				}
			}
			
	};

CVwGainTable * g_pVwGainTable;		// Modal - one and only instance
	
//-----------------------------------------------------------------------------
// Message Pump
BOOL CALLBACK GainTableDlgProc( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam) { 
	int wmId, wmEvent;
	
	switch( iMsg ) { 
		//----- DIALOG INIT -  Control Initialization
		case WM_INITDIALOG :	
			g_pVwGainTable = new CVwGainTable;
			g_pVwGainTable->m_pGainTable=(CGainTable *)lParam;
			g_pVwGainTable->m_hDlg=hDlg;			
			g_pVwGainTable->InitializeControls();
			g_pVwGainTable->Setup( );
			return TRUE;

		//----- MENU and CONTROL Commands
		case WM_COMMAND : 
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch( wmId ) { 
				case IDC_BTNDELETE :				//-- [Delete]
					g_pVwGainTable->OnBtnDelete();
					break;
					
				case IDCANCEL :						//-- [Cancel]
					g_pVwGainTable->OnBtnCancel();
					break;
					
				case IDOK :							//-- [OK]
					g_pVwGainTable->OnBtnOK();
					break;
					
				case IDC_BTNDELENTRY : 
					g_pVwGainTable->OnBtnChangeEntries(-1);
					break;

				case IDC_BTNADDENTRY : 
					g_pVwGainTable->OnBtnChangeEntries(1);
					break;
					
				}
			return TRUE;

		case WM_PAINT :
			/*		
			PAINTSTRUCT ps; 
			HDC hdc = BeginPaint(hDlg, &ps); 
			...extra drawing... 
			EndPaint(hDlg, &ps); 
			*/
			return false;

		case WM_DESTROY : 
			delete g_pVwGainTable;
			SetWindowLong( GetParent( hDlg ), 0, 0);
			return TRUE;
			
		default : 
			break;
		}
	return FALSE;
	} 

